<?php

function hdact($fb)
{
    $status = has_post('status') ? post('status') : 0;
    
    if($status == 0)  { fbcError($fb, $fb->fbc->err['10']); return false; }
        
    switch($status)
    {
        case "2":
        //Create New Folder ////////////////////////////////////////////////////
        CreateNewFolder($fb); break;
    
        case "3":
        //Create a File ////////////////////////////////////////////////////////
        CreateNewFile($fb); break;
    
        case "4":
        //Upload a File ////////////////////////////////////////////////////////
        UploadAFile($fb); break;
    
        case "5":
        //Upload from URL///////////////////////////////////////////////////////
        UploadFromURL($fb); break;
    }
}

function CreateNewFolder($fb)
{
    $name = has_post('h_text') ? filter_foldername(post('h_text')) : '';
    if(empty($name)){ fbcError($fb, $fb->fbc->err['0']); return; }
    
    $dir = $_SESSION["cur_dir"]."/".$name;
    
    $fileResult = mysqli_query($fb->mysql, "SELECT * FROM fbc_files WHERE `file_dir` = '".$dir.
            "' AND `file_name` = '".$name."' LIMIT 1;");
    
    // Check if file already exists
    if( $fileResult && mysqli_num_rows($fileResult) ) {
        fbcError($fb, $fb->fbc->err['1']); return;}
        
    if( $fileResult && !mysqli_num_rows($fileResult) ) 
    { 
        $fbc_dir_path = $_SESSION["fbc_dir"].$dir;
        
        if( !file_exists($fbc_dir_path) ) { mkdir($fbc_dir_path,0755,true); }
        if( !is_dir($fbc_dir_path) ) { fbcError($fb, $fb->fbc->err['1']); return false; }
    
        ///as path
        $fb->dbHandle['file_dir'] = $dir;
        $fb->dbHandle['file_name'] = $name;
        $fb->dbHandle['file_created'] = date("Y-m-d H:i:s", filectime($fbc_dir_path));
        $fb->dbHandle['file_modified'] = date("Y-m-d H:i:s", filemtime($fbc_dir_path));
        insertDB($fb, "fbc_files", FALSE);
        
        ///as file
        $fb->dbHandle['file_dir'] = $_SESSION["cur_dir"];
        $fb->dbHandle['file_type'] = "1";
        insertDB($fb, "fbc_files", FALSE);
    }
    else{ fbcError($fb, $fb->fbc->err['1']); return false; }
    
    return true;
}

function CreateNewFile($fb)
{
    $dir = $_SESSION["cur_dir"];
    
    $name = has_post('h_text') ? filter_filename(post('h_text')) : '';
    if(empty($name)){ fbcError($fb, $fb->fbc->err['2']); return; }
    
    $ext = pathinfo($name, PATHINFO_EXTENSION);
    
    if(!empty($ext)) { $name = substr( $name,0,strlen($name)-(strlen($ext)+1) ); } else{ $ext = '0';}
    if(empty($name)){ $name = $ext; $ext = '0';}
    
    $fileResult = mysqli_query($fb->mysql, "SELECT * FROM fbc_files WHERE `file_dir` = '".$dir.
        "' AND `file_name` = '".$name."' LIMIT 1;");
    
    // Check if file already exists
    if( $fileResult && mysqli_num_rows($fileResult) ) {
        fbcError($fb, $fb->fbc->err['3']); return;}
        
    if( $fileResult && !mysqli_num_rows($fileResult) ) 
    { 
        $fbc_file_path = $_SESSION["fbc_dir"].$_SESSION["cur_dir"]."/";
        if( !($fp = fopen($fbc_file_path.$name, 'w')) ) { fbcError($fb, $fb->fbc->err['3']); return false; }  
        fclose($fp);
    
        $fb->dbHandle['file_dir'] = $dir;
        $fb->dbHandle['file_name'] = $name;
        $fb->dbHandle['file_type'] = "2";
        $fb->dbHandle['file_ext'] = $ext;
        $fb->dbHandle['file_created'] = date("Y-m-d H:i:s", filectime($fbc_file_path.$name));
        $fb->dbHandle['file_modified'] = date("Y-m-d H:i:s", filemtime($fbc_file_path.$name));
        
        insertDB($fb, "fbc_files", FALSE);
    }
    else{ fbcError($fb, $fb->fbc->err['3']); return false; }
    
    return true;
}

function UploadAFile($fb)
{
    $dir = $_SESSION["cur_dir"];
    $fbc_file_path = $_SESSION["fbc_dir"].$_SESSION["cur_dir"]."/";
    
    $overwrite = has_post('overwrite') ;
    
    $name = filter_filename(basename($_FILES["fileToUpload"]["name"]));
    if(empty($name)){ fbcError($fb, $fb->fbc->err['2']); return; }
    
    $ext = pathinfo($name, PATHINFO_EXTENSION);
    
    if(!empty($ext)) { $name = substr( $name,0,strlen($name)-(strlen($ext)+1) ); } else{ $ext = '0';}
    if(empty($name)){ $name = $ext; $ext = '0';}
    
    // Check upload completed
    if ($_FILES["fileToUpload"]["error"]) {
        fbcError($fb, $fb->fbc->err['6']); return;} 
        
    // Check if file already exists
    if( file_exists($fbc_file_path.$name) && !$overwrite ) {
        fbcError($fb, $fb->fbc->err['4']); return;}
    
    // Check file size
    if ($_FILES["fileToUpload"]["size"] > 2048000) {
        fbcError($fb, $fb->fbc->err['5']); return;} 

    $fileResult = mysqli_query($fb->mysql, "SELECT * FROM fbc_files WHERE `file_dir` = '".$dir.
        "' AND `file_name` = '".$name."' LIMIT 1;");
    
    if( $fileResult && mysqli_num_rows($fileResult) )
    {
        mysqli_query($fb->mysql, "DELETE FROM fbc_files WHERE `file_dir` = '".$dir.
        "' AND `file_name` = '".$name."' LIMIT 1;");
    }
    
    $file = file_get_contents($_FILES["fileToUpload"]["tmp_name"]);
    $cDate = date("Y-m-d H:i:s");
    
    $cipher = new Crypt_RC4();
    $pPsw = base64_decode($fb->accountNumber);
    $cipher->setKey($pPsw.$cDate);
    
    if( $fileResult ) 
    { 
        if( !($fp = fopen($fbc_file_path.$name, 'w')) ) { fbcError($fb, $fb->fbc->err['3']); return false; }
        if( !fwrite($fp, $cipher->encrypt($file)) ) { fbcError($fb, $fb->fbc->err['3']); return false; } 
        fclose($fp);
    
        $fb->dbHandle['file_dir'] = $dir;
        $fb->dbHandle['file_name'] = $name;
        $fb->dbHandle['file_type'] = "2";
        $fb->dbHandle['file_ext'] = $ext;
        $fb->dbHandle['file_created'] = $cDate;
        $fb->dbHandle['file_size'] = $_FILES["fileToUpload"]["size"];
        $fb->dbHandle['file_modified'] = date("Y-m-d H:i:s", filemtime($fbc_file_path.$name));
        
        insertDB($fb, "fbc_files", FALSE);
    }
    else{ fbcError($fb, $fb->fbc->err['3']); return false; }
    
    return true;
}

function UploadFromURL($fb)
{
    $file = null;
    $dir = $_SESSION["cur_dir"];
    $fbc_file_path = $_SESSION["fbc_dir"].$_SESSION["cur_dir"]."/";
    
    $overwrite = has_post('overwrite') ;
    
    $fpath = has_post('h_text') ? urldecode(post('h_text')) : '';
    if(empty($fpath)){ fbcError($fb, $fb->fbc->err['2']); return; }
    
    $name = filter_filename(basename($fpath));
    if(empty($name)){ fbcError($fb, $fb->fbc->err['2']); return; }
    
    $ext = pathinfo($name, PATHINFO_EXTENSION);
    
    if(!empty($ext)) { $name = substr( $name,0,strlen($name)-(strlen($ext)+1) ); } else{ $ext = '0';}
    if(empty($name)){ $name = $ext; $ext = '0';}
    
    // get file
    if ( !($file = file_get_contents($fpath)) ) {
        fbcError($fb, $fb->fbc->err['7']); return;} 
        
    // Check if file already exists
    if( file_exists($fbc_file_path.$name) && !$overwrite ) {
        fbcError($fb, $fb->fbc->err['4']); return;}
    
    // Check file size
    if (strlen($file) > 5120000) {
        fbcError($fb, $fb->fbc->err['5']); return;} 

    $fileResult = mysqli_query($fb->mysql, "SELECT * FROM fbc_files WHERE `file_dir` = '".$dir.
        "' AND `file_name` = '".$name."' LIMIT 1;");
    
    if( $fileResult && mysqli_num_rows($fileResult) )
    {
        mysqli_query($fb->mysql, "DELETE FROM fbc_files WHERE `file_dir` = '".$dir.
        "' AND `file_name` = '".$name."' LIMIT 1;");
    }
    
    $cDate = date("Y-m-d H:i:s");
    
    $cipher = new Crypt_RC4();
    $pPsw = base64_decode($fb->accountNumber);
    $cipher->setKey($pPsw.$cDate);
    
    if( $fileResult ) 
    { 
        if( !($fp = fopen($fbc_file_path.$name, 'w')) ) { fbcError($fb, $fb->fbc->err['3']); return false; }
        if( !fwrite($fp, $cipher->encrypt($file)) ) { fbcError($fb, $fb->fbc->err['3']); return false; } 
        fclose($fp);
    
        $fb->dbHandle['file_dir'] = $dir;
        $fb->dbHandle['file_name'] = $name;
        $fb->dbHandle['file_type'] = "2";
        $fb->dbHandle['file_ext'] = $ext;
        $fb->dbHandle['file_created'] = $cDate;
        $fb->dbHandle['file_size'] = strlen($file);
        $fb->dbHandle['file_modified'] = date("Y-m-d H:i:s", filemtime($fbc_file_path.$name));
        
        insertDB($fb, "fbc_files", FALSE);
    }
    else{ fbcError($fb, $fb->fbc->err['3']); return false; }
    
    return true;
}